#         Portable Batch System (PBS) Software License
# 
# Copyright (c) 1999, MRJ Technology Solutions.
# All rights reserved.
# 
# Acknowledgment: The Portable Batch System Software was originally developed
# as a joint project between the Numerical Aerospace Simulation (NAS) Systems
# Division of NASA Ames Research Center and the National Energy Research
# Supercomputer Center (NERSC) of Lawrence Livermore National Laboratory.
# 
# Redistribution of the Portable Batch System Software and use in source
# and binary forms, with or without modification, are permitted provided
# that the following conditions are met:
# 
# - Redistributions of source code must retain the above copyright and
#   acknowledgment notices, this list of conditions and the following
#   disclaimer.
# 
# - Redistributions in binary form must reproduce the above copyright and 
#   acknowledgment notices, this list of conditions and the following
#   disclaimer in the documentation and/or other materials provided with the
#   distribution.
# 
# - All advertising materials mentioning features or use of this software must
#   display the following acknowledgment:
# 
#   This product includes software developed by NASA Ames Research Center,
#   Lawrence Livermore National Laboratory, and MRJ Technology Solutions.
# 
#         DISCLAIMER OF WARRANTY
# 
# THIS SOFTWARE IS PROVIDED BY MRJ TECHNOLOGY SOLUTIONS ("MRJ") "AS IS" WITHOUT 
# WARRANTY OF ANY KIND, AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING,
# BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS
# FOR A PARTICULAR PURPOSE, AND NON-INFRINGEMENT ARE EXPRESSLY DISCLAIMED.
# 
# IN NO EVENT, UNLESS REQUIRED BY APPLICABLE LAW, SHALL MRJ, NASA, NOR
# THE U.S. GOVERNMENT BE LIABLE FOR ANY DIRECT DAMAGES WHATSOEVER,
# NOR ANY INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
# CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
# OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE
# USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
# 
# This license will be governed by the laws of the Commonwealth of Virginia,
# without reference to its choice of law rules.
################################################################################
# hold: defines the layout and functions of the select owners criteria
#       dialog box.
proc owners {} {
  global LABELFONT ownersDialogBox activeWindow selv select_args \
	 selv_useru selv_userh

  busy_cursor
## Bring up the standard Dialog box ##
  set ownersDialogBox ".owners"
  set dbox [popupDialogBox $ownersDialogBox "Select Owners Criteria" 1 SelOwners "" 1]
  set activeWindow($ownersDialogBox) 1
  set dbox_top    [lindex $dbox 0]
  set dbox_bottom [lindex $dbox 1]

## BOTTOM PART ##
  set cmdButtons \
  [buildCmdButtons $dbox_bottom {{{ok ok} {help help}}} x 2m 18 3]

  set cmdFrame  [lindex $cmdButtons 0]
  set cmdOk     [lindex $cmdButtons 1]
  set cmdHelp   [lindex $cmdButtons 2]
  
  $cmdHelp configure -command {xpbs_help select.owners $ownersDialogBox}

  $cmdOk configure -command {
    switch -exact -- $selv(owner_option) {
      user {
        set size 0
        if [info exists selv_useru] {
	  set size [array size selv_useru]
        }
        for {set i 0} {$i < $size} {incr i} {

        if { [trimvar "@," selv_useru($i)] || \
             [trimvar "@," selv_userh($i)] } {
            popupInfoBox $ownersDialogBox "Detected an illegal character \"@\" \
                         or \",\" within username/hostname. Please remove."
            return
          }

          if {[string compare $selv_useru($i) ""] == 0 && \
              [string compare $selv_userh($i) ""] != 0} {
	    popupInfoBox $ownersDialogBox "Owner list entry $i is incomplete"
	    return
          }	 

          if {[string compare $selv_userh($i) ""] != 0 || \
              [string compare $selv_useru($i) ""] != 0} {

	    if {[string compare $selv_userh($i) ""] == 0} {
              set userlist($i) "$selv_useru($i)"
	    } else {
              set userlist($i) "$selv_useru($i)@$selv_userh($i)" 
	    }
          }
        }
        if [info exists userlist] {
          set user_args [construct_array_args userlist ","]
        } else {
          set user_args ""
        }

        if {[string compare $user_args ""] == 0} {
  	  popupInfoBox $ownersDialogBox "Please specify an Owners list argument."
          return
        } else {
          set selv(owners_list) "Owners: $user_args"
        }
	catch {unset userlist} 
      }
      ANY {set selv(owners_list) "Owners: -ANY-"}
    }
    destroy $ownersDialogBox
  }

## TOP PART ##
  frame $dbox_top.header -height 10m -width 10m
  frame $dbox_top.footer -height 10m -width 10m

  frame $dbox_top.u
  frame $dbox_top.u.main
  frame $dbox_top.u.main.o

  set selv(user_frame) $dbox_top.u.main.o

  box $selv(user_frame) -title "" -entrylabels [list "user" "host"] \
        -lboxlabels [list "Owners:" " "]  -lboxwidths [list 20 20] \
	-lboxheights [list 3 3] \
        -orient y -array 0 selv_useru -array 1 selv_userh \
	-grabBox $ownersDialogBox

  set radioList [list    {a "ANY"} \
			[concat  list \"\" $selv(user_frame)]]

  pack $selv(user_frame)
  set rbox [buildRadioboxes $dbox_top.u.main [list $radioList] \
                            column 5 "Owners = "]
  set rboxFrame    [lindex $rbox 0]
  set selv(rboxANY)      [lindex $rbox 1]
  set selv(rboxUser)     [lindex $rbox 2]

  $selv(rboxUser) configure -variable selv(owner_option) -value user -command {
  				box $selv(user_frame) enable
  			    }
  $selv(rboxANY) configure   -variable selv(owner_option) -value ANY -command {
  				box $selv(user_frame) disable
     			    }


### PACK the FRAMES
  pack $rboxFrame -anchor nw

  pack $dbox_top.header $dbox_top.u $dbox_top.footer -side top -anchor nw \
	-padx 5m

  set owner_arg [lindex $selv(owners_list) 1]
  switch -regexp -- $owner_arg {
    "ANY"       {$selv(rboxANY) invoke}
    default     {
	$selv(rboxUser) invoke
        load_argstr $owner_arg , {selv_useru selv_userh} {@}
    }
  }

  register_default_action SelOwners $cmdOk

  tkwait visibility $ownersDialogBox
  boxLoad $selv(user_frame)
  remove_busy_cursor
  catch {tkwait window $ownersDialogBox} result
  boxesUnset
  set activeWindow($ownersDialogBox) 0
}
